#!/usr/bin/env python
# Name: Timothy Myers
# A very simple ldap client
# If the script is run with no arguments, it produces information on
# all users that have logged into CSC3550-3.LOCAL.
# If the script is run with one argument, it produces information on
# all users that have logged into CSC3550-3.LOCAL whose name starts with 
# the argument
# This is a Python 2.7 script
import sys
import ldap
 
if len(sys.argv) > 1:
   value = sys.argv[1]
else:
   value = ""

stri = 'ldap://149.149.135.62:%d/' % (ldap.PORT)
print stri
l = ldap.initialize(stri)
dn = "cn=Users,dc=CSC3550-3,dc=local"
sear = "cn=Users,dc=CSC3550-3,dc=local"

ans = l.simple_bind_s("cn=Timothy E. Myers,"+dn,"P0wr%B4sh$")
filt = "(&(cn="+value+"*)(&(logonCount=*)(!(logonCount=0))))"
attrs = ['logonCount','cn','displayName','givenName','name']
for name, stuff in l.search_s(sear,ldap.SCOPE_ONELEVEL,filt,attrs):
   print "################################################"
   print "Name: "+name
   print "Keys and values"
   for key in sorted(stuff.keys()):
      print "\t"+key+"\n\t\t"+stuff[key][0]


