# AHMED ALMOHSIN
# WebParser - SYSTEMS PROGRAMMING
# ERIC BROWN
# IMPORT NEEDED SUPPORT MODULES
#!/usr/bin/python
import bz2
import urllib
import apachelog
import sys
import re

getFile = urllib.urlretrieve("http://users.csc.tntech.edu/~elbrown/access_log.bz2")
deCompress = bz2.BZ2File(getFile[0])

format = r'"%h %l %u %t \"%r\" %>s %b \"%{Referer}i\" \"%{User-Agent}i\"'
p = apachelog.parser(format)

def realSort(L, reverse=False): 
    
    convert = lambda text: ('', int(text)) if text.isdigit() else (text, 0) 
    alphanum = lambda key: [ convert(c) for c in re.split('([0-9]+)', key) ] 
    return sorted(L, key=alphanum, reverse=reverse)
    
#List of Web Browsers
browserList = [(re.compile("Firefox",),"Firefox"),(re.compile("MSIE 5.0"),"MSIE 5.0"),
    (re.compile("MSIE 6.0"),"MSIE 6.0"),(re.compile("MSIE 7.0"),"MSIE 7.0"),
    (re.compile("Safari"),"Safari"),(re.compile("Opera"),"Opera"),
    (re.compile("Konqueror"),"Konqueror"),(re.compile("Iceweasel"),"Iceweasel"),
    (re.compile("BonEcho"),"Bon Echo"),(re.compile("Netscape"),"Netscape"),
    (re.compile("Camino"),"Camino")]

#List of Operating Systems
osList = [(re.compile("Mac OS X"),"Mac OS X"),(re.compile("Windows"),"Windows"),
    (re.compile("Linux"),"Linux"),(re.compile("SunOS"),"SunOS"),
    (re.compile("FreeBSD"),"FreeBSD"),(re.compile("OpenBSD"),"OpenBSD"),
    (re.compile("Wii"),"Wii")]


#Declaring arrays and variables to store and count
ip = {}
browsers = {}
sites = {}
day = {}
oncampus_hits = 0.0
offcampus_hits = 0.0
num404 = 0
num500 = 0
line = deCompress.readline()

print "Please Wait..."

while(line != ''):
    try:
        
        data = p.parse(line)
        
        d = re.search('\d+/\w+/\d+',data['%t'])
        date = d.group()
        
        address = re.match('149\.149\.\d+\.\d+',data['"%h'])
        
        for pat,name in browserList:
            if re.search(pat,data["%{User-Agent}i"]):
                agent = name
                break
            else:
                agent = "Other Browser"
        for pat,name in osList:
            if re.search(pat,data["%{User-Agent}i"]):
                os = name
                break
            else:
                os = "Other OS"
                
        
        if agent == "Other Browser" and os == "Other OS":
            userAgent = "Robot"
        else:
            userAgent = agent + " - " + os
        
       
        if address:
            oncampus_hits += 1
        else:
            offcampus_hits += 1
            
        
        if ip.has_key(data['"%h']):
            ip[data['"%h']] = ip[data['"%h']] + 1
        else:
            ip[data['"%h']] = 1
            
       
        if browsers.has_key(userAgent):
            browsers[userAgent] = browsers[userAgent] + 1
        else:
            browsers[userAgent] = 1
        
        
        if day.has_key(date):
            day[date] = day[date] + 1
        else:
            day[date] = 1
            
        
        if data['%>s'] == "404":
            num404 += 1
        else:
            if data['%{Referer}i'] != "-":
                if sites.has_key(data['%{Referer}i']):
                    sites[data['%{Referer}i']] = sites[data['%{Referer}i']] + 1
                else:
                    sites[data['%{Referer}i']] = 1
                    
        if data['%>s'] == "500":
            num500 += 1
    except:
        """ """
    line = deCompress.readline()
    
ipSort = list()
browserSort = list()
siteSort = list()
countDay = 0
count = 0


for add,num in ip.items():
    ipSort.append(str(num) + " - " + add)
for web,num in browsers.items():
    browserSort.append(str(num) + " - " + web)
for web,num in sites.items():
    siteSort.append(str(num) + " - " + web)
for da,num in day.items():
    countDay += num
    

ipSort = realSort(ipSort,True)
browserSort = realSort(browserSort,True)
siteSort = realSort(siteSort,True)


print "Top 20 IP Addresses:"
while count < 20:
    print ipSort[count]
    count += 1
count = 0    

print "Unique List of Web Browsers:"
while count < len(browserSort):
    print browserSort[count]
    count += 1
count = 0

print "Top 20 Web Pages:"
while count < 20:
    print siteSort[count]
    count += 1


totalhits = oncampus_hits + offcampus_hits
avgon = '%.2f' % ((oncampus_hits/totalhits) * 100)
avgoff = '%.2f' % ((offcampus_hits/totalhits) * 100)
print "On Campus Hits: "+str(avgon)+"%"
print "Off Campus Hits: "+str(avgoff)+"%"


avgdayhits = countDay / len(day)
print "Average Number of Hits per Day: "+str(avgdayhits)

print "Total Number of 404 Errors: "+str(num404)
print "Total Number of 500 Errors: "+str(num500)
