#!/usr/bin/env ruby
# Name: Timothy Myers
# A DNS client
require 'socket'
include Socket::Constants

# This script gets the address(es) for the domain name on the command line

# function that was used print the sent and recieved packet
def printHex(s)
   for char in 0...s.length
      print "%02X" % s[char]+" "
   end
   puts ""
end

hostname = '149.149.134.25'
port = 53

name = ARGV[0]
puts "Finding addresses for "+name

#Open the socket for the dns server
s = UDPSocket.open()
s.connect(hostname, port)


idn = [1]
# id of 1
send = idn.pack('n')
# bit set for recursion requested
send += "\1\0"
# 1 question
header = [1,0,0,0]
send += header.pack('n4')
# formatting name correctly
parts = name.split('.')
for i in 0...parts.length
   arr = [parts[i].length.to_s]
   send += arr.pack("h") + parts[i]
end
arr = ["0"]
send += arr.pack('b')
# query class and type
arr = [1,1]
send += arr.pack('n2')

#Send and get back response
s.send(send,0)
data  = s.recvfrom(1024)
if data

   puts 'DNS server ', data[1][3], "\n"

   data = data[0]

   
   head = data[0,12].unpack('n6')
   ans = head[3]
   # remove the header and question
   data = data[send.length,data.length]
   if ans == 0
      puts "There are no addresses"
      exit
   end

   if data.length == 16 * ans
      puts "There are "+ans.to_s+" addresses."
      for i in 0...ans
         value = data[12,4]
         data = data[16,data.length]

         # convert last 4 bytes into dotted decimal ip
         ip = value.unpack('C4')
         value = ip[0].to_s+"."+ip[1].to_s+"."+ip[2].to_s+"."+ip[3].to_s
         puts value 
      end

   else
      puts "Answer not recognizable"
   end

else
	print "Incorrect return\n"

end
s.close
exit
