#!/usr/bin/env python
# Name: Timothy Myers
# A very simple DNS client
# Source code for pydig was used to get idea's and some formatting:
# www.huque.com/software/pydig/
# This is a Python 2.7 script
from socket import *
import struct,time,sys
 
# Script gets the IP address for the domain name given on the command line

# this function allows for the checking of the sent and recieved packets
#print a binary string as hex digits
def printHex(s):
   for char in s:
      print "%02X" % ord(char)+" ",
   print ""

dns_server = ('149.149.134.25', 53)
value = sys.argv[1]
print "Finding addresses for "+value
 
 
# opens socket
client = socket( AF_INET, SOCK_DGRAM )
 
#id number
idn = struct.pack('!H',1)
# the bit for recursion desired is set
flags = '\1\0'
# 1 question
qdcount = struct.pack('!H',1)
ancount = struct.pack('!H',0)
nscount = struct.pack('!H',0)
arcount = struct.pack('!H',0)
ques = ""
# formatting the question correctly
for part in value.split('.'):
   ques += struct.pack('B',len(part)) + part
ques += struct.pack('B',0)
# the query type and class
ques += struct.pack('!H',1) + struct.pack('!H',1)

send = idn + flags + qdcount + ancount + nscount + arcount + ques


client.sendto(send, dns_server)
 
data, address = client.recvfrom( 1024 )
 
if data:
   print 'DNS Server', address,'\n'



   a,b,c,ans,e,f = struct.unpack('!HHHHHH',data[:12])
   #we get everything given except what we sent
   answers = data[len(send):]
   if ans == 0:
      print "There are no addresses"
      exit(0)

   # this assumes that the name in the answer is a pointer to the question
   if len(answers) == 16 * ans:
      print 'There are '+str(ans)+' addresses'

      for i in range(ans):
         value = answers[12:16]
         answers = answers[16:]

         # concatonate the last 4 bytes for the address
         ip0, ip1, ip2, ip3 = struct.unpack('BBBB',value)
         val = str(ip0)+"."+str(ip1)+"."+str(ip2)+"."+str(ip3)
         print val 

   else:
      print "Answer not recognizable"
else:
    raise 'no data returned'
