#!/usr/bin/env ruby
# Name: Timothy Myers
# A very simple ldap client
# If the script is run with no arguments, it produces information on
# all users that have logged into CSC3550-3.LOCAL.
# If the script is run with one argument, it produces information on
# all users that have logged into CSC3550-3.LOCAL whose name starts with 
# the argument
require 'rubygems'
require 'net/ldap'

name = ARGV[0]

treebase = "cn=Users,dc=CSC3550-3,dc=local"
l = Net::LDAP.new :host => "149.149.135.62", :auth => {:method => :simple, :username => "cn=Timothy E. Myers,#{treebase}", :password => "P0wr%B4sh$"}

filter = Net::LDAP::Filter.eq("cn", "#{name}*") & Net::LDAP::Filter.pres("logoncount") & ~Net::LDAP::Filter.eq("logoncount", "0")
attrs = ["dn","name","givenname","sn","displayname","logoncount"]
if l.bind
   puts "bind successful"
   l.search(:base => treebase, :filter => filter, :attributes =>attrs,
      :scope => Net::LDAP::SearchScope_SingleLevel) do |entry|
      #list = entry.attribute_names 
      #list.each do |name|
         #puts name
      #end
      puts "###########################################################"
      entry.each do |attr, values|
         puts "#{attr} is(are) :"
         values.each do |value|
            puts "\t#{value}"
         end
      end
   end
else
   puts "bind failed"
   p l.get_operation_result
end
