#!/usr/bin/python
# Name: Timothy Myers
# This script creates people in the form of:
# Full Name,ID number,e-mail address,{home phone number; cell phone number; work number},Department
# It creates as many people as are given on the command line as an argument
# 
# This is a Python 2.7 script

import random
import urllib2
import sys

def main(argv):
   if not len(argv) == 2:
      num = 1
   else:
      if not argv[1].isdigit():
         num = 1
      else:
         num = int(argv[1])
   #create a peoplegen to make num people
   gen = peoplegen(num)
   #start generating data
   names = gen.genNames()
   ids = gen.genIDs()
   #need to give it names to seed emails
   emails = gen.genEmails(names)
   phonenums = gen.genNumbers()
   depts = gen.genDepts()
   for i in range(num):
      print names[i] + ',' +  ids[i] + ','+emails[i] + ',' + phonenums[i] + ',' + depts[i]

class peoplegen:
   def __init__(self, num):
      #self.num is the number of entries to create
      self.num = num

   def genNames(self):
      loop = 0;
      #read all of the name files into strings
      site = urllib2.urlopen("http://www.census.gov/genealogy/names/dist.all.last")
      lnames = site.read()
      site = urllib2.urlopen("http://www.census.gov/genealogy/names/dist.male.first")
      mfnames = site.read()
      site = urllib2.urlopen("http://www.census.gov/genealogy/names/dist.female.first")
      ffnames = site.read()

      #break strings into lists of lines
      lnames = lnames.splitlines()
      mfnames = mfnames.splitlines()
      ffnames = ffnames.splitlines()

      #return list
      namelist = list()

      while loop < self.num:
         #generate a number to determine person sex
         gen = random.randint(0,1)
         if gen == 0:
            fnames = mfnames
         else:
            fnames = ffnames
         #generate number of names
         numname = random.randint(2,5)
         name = ''
         i = 0
         #loop gets the first name and middle names
         while i < numname-1:
            # i am going to walk you through the next line
            #             random index in fnames           split on space and only take the name at the beginning
            name += fnames[random.randint(0,len(fnames)-1)].split(' ',1)[0]+' '
            i += 1
         #add last name
         name += lnames[random.randint(0,len(lnames)-1)].split(' ',1)[0]
         i = 1
         # if number generated is 1, person has suffix
         if i == random.randint(1,4):
            j = random.randint(1,4)
            if j == 1:
               name += ' Sr'
            elif j == 2:
               name += ' Jr'
            elif j == 3:
               name += ' III'
            else:
               name += ' II'
         # ensure unique names
         if namelist.count(name) > 0:
            continue
         namelist.append(name)
         loop += 1

      return namelist
   
   def genIDs(self):
      # return list
      ids = list()
      loop = 0
      while loop < self.num:
         idnum = ''
         #generate 9 numbers
         i = 0
         while i < 9:
            idnum += str(random.randint(0,9))
            i += 1
         #ensure uniquiness
         if ids.count(idnum) > 0:
            continue
         ids.append(idnum)
         loop += 1
      return ids

   def genEmails(self, names):
      #return list
      ems = list()
      i = 0;
      while i in range(self.num):
         #we generate emails based on names
         # split names in 
         splnm = names[i].split()
         offset = 0
         # we don't want to include a suffix in the e-mail 
         # if it exists, so we check againt a suffix list
         suffix = ['jr','junior','jr.','sr','sr.','senior','i','ii','iii','iv','v','1','2','3','4','5']
         if suffix.count(splnm[len(splnm)-1].lower()) > 0:
            offset = 1
         j = 1
         # loop for all of the names 
         for j in range(len(splnm)-1-offset):
            # always add the first name
            eml = splnm[0]+'.'
            # add the middle names one at a time if needed
            for k in range(1,j):
               eml += splnm[k]+'.'
            #always add the last non suffix name
            eml += splnm[len(splnm)-1-offset]+'@organization.edu'
            # remove troublesome apostrophes
            eml = eml.split('\'')
            emls = ""
            for k in range(len(eml)):
               emls += eml[k]
            eml = emls
            # if it is unique, exit loop and place in list
            if ems.count(eml) == 0:
               break
         ems.append(eml)
         i += 1
      return ems
   
   def genNumbers(self):
      # return list
      numlist = list()
      #sets for all users
      for i in range(self.num):
         # slap first { in string
         num = '{'
         #get tuples
         for j in range(3):
            version = random.randint(1,4)
            # version 1 = (1-)###-###-####
            if version == 1:
               longd = random.randint(1,4)
               if longd == 1:
                  num += '1-'
               for k in range(3):
                  num += str(random.randint(0,9))
               num += '-'
               for k in range(3):
                  num += str(random.randint(0,9))
               num += '-'
               for k in range(4):
                  num += str(random.randint(0,9))
            #version 2 = (1)(###)###-####
            elif version == 2:
               longd = random.randint(1,4)
               if longd == 1:
                  num += '1'
               num += '('
               for k in range(3):
                  num += str(random.randint(0,9))
               num += ')'
               for k in range(3):
                  num += str(random.randint(0,9))
               num += '-'
               for k in range(4):
                  num += str(random.randint(0,9))
            #version 3 = (1.)###.###.####
            elif version == 3:
               longd = random.randint(1,4)
               if longd == 1:
                  num += '1.'
               for k in range(3):
                  num += str(random.randint(0,9))
               num += '.'
               for k in range(3):
                  num += str(random.randint(0,9))
               num += '.'
               for k in range(4):
                  num += str(random.randint(0,9))
            #version 4 = (1)##########
            else: 
               longd = random.randint(1,4)
               if longd == 1:
                  num += '1'
               for k in range(10):
                  num += str(random.randint(0,9))
            if j < 2:
               num += ';'
         num += '}'
         numlist.append(num)
      return numlist

   def genDepts(self):
      # return list
      deptlist = list()
      # Choose a department
      for i in range(self.num):
         selection = random.randint(1,5)
         if selection == 1:
            deptlist.append('Marketing')
         elif selection == 2:
            deptlist.append('Human Resourses')
         elif selection == 3:
            deptlist.append('Sales')
         elif selection == 4:
            deptlist.append('Design')
         elif selection == 5:
            deptlist.append('Testing')
      return deptlist;
               

if __name__ == "__main__":
   sys.exit(main(sys.argv))
